'''
Created on Jan 30, 2012

@author: prgantonino
'''
import os
import sys
import Config
import math
import datetime

def executeAndGenerateResults(n):
    path = Config.PATH + "gerador/Gerados/Max_" + str(n) + "/"
    log_path = path + "LOG/"
    if not(os.path.exists(log_path)):
        os.makedirs(log_path) 
    os.environ["FDRHOME"] = Config.FDRHOME
    os.system("(time " + Config.FDRHOME + "bin/fdr2 batch " + path + "phils.csp ) >> " + log_path + "phils.log 2>&1")
    print "Executing n="+str(n)
    
def checkForError(n):
    path = Config.PATH + "gerador/Gerados/Max_" + str(n) + "/"
    log_path = path + "LOG/phils.log"
    error = False
    try:
        with open(log_path, "r") as file:
            line = file.readline()
            while(line != "" and not error):
                if(line.startswith("false") or line.startswith("xfalse") or line.startswith("The CSP compiler detected a script error or interrupt")):
                    error = True
                    print "Error script problem or assertion violated"
                line = file.readline()
        file.close()
    except:
        print "Exception"
        return 1
    return error

def executeAndGenerateResultsSeg(n):
    path = Config.PATH + "gerador/Gerados/MAX_SEG_" + str(n) + "/"
    log_path = path + "LOG/"
    if not(os.path.exists(log_path)):
        os.makedirs(log_path) 
    os.environ["FDRHOME"] = Config.FDRHOME
    ppf = Config.PROC_PER_FILE
    top = int(math.ceil(n/ppf))
    for i in range(0,top):
        os.system("(time " + Config.FDRHOME + "bin/fdr2 batch " + path + "phils_div"+str(i)+".csp ) >> " + log_path + "phils_div"+str(i)+".log 2>&1")
    print "Executing n="+str(n)
    
def checkForErrorSeg(n):
    path = Config.PATH + "gerador/Gerados/MAX_SEG_" + str(n) + "/"
    ppf = Config.PROC_PER_FILE
    top = int(math.ceil(n/ppf))
    for i in range(0,top):
        error = False
        log_path = path + "LOG/phils_div"+str(i)+".log"
        try:
            with open(log_path, "r") as file:
                line = file.readline()
                while(line != "" and not error):
                    if(line.startswith("false") or line.startswith("xfalse") or line.startswith("The CSP compiler detected a script error or interrupt")):
                        error = True
                        print "Error script problem or assertion violated"
                    line = file.readline()
            file.close()
        except:
            print "Exception"
            return 1
    return error
     
if __name__ == '__main__':
    
    max = int(sys.argv[1])
    print datetime.datetime.now()
   # max = 10000
    executeAndGenerateResultsSeg(max)
    print datetime.datetime.now()
#    error = checkForErrorSeg(max)
#    if error == False:
#        print "Success. Assertion and Script OK!"
    
