'''
Created on Jan 31, 2012

@author: prgantonino
'''
import sys
from TemplateCSP import Templates
import os
from Cheetah.Template import Template
TRANSITION = 1
STATE = 2
TIME = 3
def parseTime(time):
    split = time.split("e")
    elapsed = split[0]
    hasMSeg = False
    print elapsed
    elapsedSplit = elapsed.split(".")
    print elapsedSplit
    if(len(elapsedSplit) > 1):
        mseg = elapsedSplit[1]
        hasMSeg = True
    minHours = elapsedSplit[0].split(":")
    second = minHours[1]
    first = minHours[0]
    ms = 0
    if(hasMSeg):
        ms = int(first) * 60 * 1000
        ms = ms + int(second) * 1000
        ms = ms + int(mseg) * 10
    else:
        third = minHours[2]
        ms = int(first) * 24 * 60 * 1000
        ms = ms + int(second) * 60 * 1000
        ms = ms + int(third) * 1000
    return ms
    
def getSum(file_name, prefix, hasWord, index, time=False):
    sum = 0
    try:
        with open(file_name, "r") as file:
            line = file.readline()
            while(line != ""):
                if(line.startswith(prefix) and line.find(hasWord) != -1):
                    splitSet = line.split()
                    if not(time):
                        sum = sum + int(splitSet[index].replace(",", ""))
                    else:
                        sum = sum + parseTime(splitSet[index])
                    
                line = file.readline()
        file.close()
        print "fileName"+file_name+" index: "+str(index)+" sum: "+str(sum)
    except:
        print "Exception"
        return 1
    return sum

def getSumTime(file_name, prefix, hasWords, index):
    sum = 0
    #try:  
    print "getting time:"
    with open(file_name, "r") as file:
        line = file.readline()
        #print line
        while(line != ""):
            if(line.find(hasWords[0]) != -1 and line.find(hasWords[1]) != -1 and line.find(hasWords[2]) != -1):
                print "line"+str(line)
                splitSet = line.split()
                print "split"+str(splitSet)
                sum = sum + parseTime(splitSet[index])
            line = file.readline()
    file.close()
    print "sum" + str(sum)
#except:
    #print "exception"
#return 1
    return sum


def getTotalWhole(n, path, dead, type):
    step_path = path + "WholeSystem_Max_" + str(n) + "/"
    if dead:
        log_path = step_path + "LOG/DEAD_SYSTEM.log"
    else:
        log_path = step_path + "LOG/SYSTEM.log"
    if type == TIME:
        return getSumTime(log_path, "", ["system", "elapsed", "CPU"], 2)
    elif type == STATE:
        return getSum(log_path, "Refine", "state", 2)
    elif type == TRANSITION:
        return getSum(log_path, "With", "transitions", 1)
    
def getTotalByLevel(n, path, dead, type, level):
    step_path = path + "ByLevel_Max_" + str(n) + "/"
    if dead:
        log_path = step_path + "Level_" + str(level) + "/LOG/DEAD_SYSTEM.log"
    else:
        log_path = step_path + "Level_" + str(level) + "/LOG/SYSTEM.log"
    if type == TIME:
        return getSumTime(log_path, "", ["system", "elapsed", "CPU"], 2)
    elif type == STATE:
        return getSum(log_path, "Refine", "state", 2)
    elif type == TRANSITION:
        return getSum(log_path, "With", "transitions", 1)

def getTotalStepByStep(n, path, dead, type):
    step_path = path + "StepByStep_Max_" + str(n) + "/"
    if dead:
        log_path = step_path + "LOG/DEAD_SYSTEM.log"
    else:
        log_path = step_path + "LOG/SYSTEM.log"
    if type == TIME:
        return getSumTime(log_path, "", ["system", "elapsed", "CPU"], 2)
    elif type == STATE:
        return getSum(log_path, "Refine", "state", 2)
    elif type == TRANSITION:
        return getSum(log_path, "With", "transitions", 1)
    
def getTemplateVar(i, template, type):
    if i == 1:
        if type == "state":
             template.level_1_state
        elif type == "transition":
            return template.level_1_transition
        elif type == "time":
            return template.level_1_time
    elif i == 2:
        if type == "state":
            return template.level_2_state
        elif type == "transition":
            return template.level_2_transition
        elif type == "time":
            return template.level_2_time
    elif i == 3:
        if type == "state":
            return template.level_3_state
        elif type == "transition":
            return template.level_3_transition
        elif type == "time":
            return template.level_3_time
    elif i == 4:
        if type == "state":
            return template.level_4_state
        elif type == "transition":
            return template.level_4_transition
        elif type == "time":
            return template.level_4_time
    elif i == 5:
        if type == "state":
            return template.level_5_state
        elif type == "transition":
            return template.level_5_transition
        elif type == "time":
            return template.level_5_time
    
def gerarReportTemplate(n, path):
    #if not(os.path.exists(path)):
     #   os.makedirs(path)
    max = n
    templates = Templates("/home/pedro/Pedro/Ferramenta2.1/Templates/")
    name = "report" + str(n) + ".csv"
    generateFile = open(path + "Reports/" + name, "w")
    templateFile = templates.getReport()
    template = Template(templateFile)
   
    template.whole_system_transition = getTotalWhole(max, path , False, TRANSITION)
    template.whole_system_state = getTotalWhole(max, path, False, STATE)
    template.whole_system_time = getTotalWhole(max, path, False, TIME)
    
    template.whole_dead_system_transition = getTotalWhole(max, path, False, TRANSITION)
    template.whole_dead_system_state = getTotalWhole(max, path, False, STATE)
    template.whole_dead_system_time = getTotalWhole(max, path, False, TIME)

    template.step_system_transition = getTotalStepByStep(max, path, False, TRANSITION)
    template.step_system_state = getTotalStepByStep(max, path, False, STATE)
    template.step_system_time = getTotalStepByStep(max, path, False, TIME)
    
    template.step_dead_system_transition = getTotalStepByStep(max, path, False, TRANSITION)
    template.step_dead_system_state = getTotalStepByStep(max, path, False, STATE)
    template.step_dead_system_time = getTotalStepByStep(max, path, False, TIME)
    
    template.level_1_transition = getTotalByLevel(max, path, False, TRANSITION, 2)
    template.level_1_state = getTotalByLevel(max, path, False, STATE, 2)
    template.level_1_time = getTotalByLevel(max, path, False, TIME, 2)
    
    template.level_2_transition = getTotalByLevel(max, path, False, TRANSITION, 2)
    template.level_2_state = getTotalByLevel(max, path, False, STATE, 2)
    template.level_2_time = getTotalByLevel(max, path, False, TIME, 2)
    
    template.level_3_transition = getTotalByLevel(max, path, False, TRANSITION, 3)
    template.level_3_state = getTotalByLevel(max, path, False, STATE, 3)
    template.level_3_time = getTotalByLevel(max, path, False, TIME, 3)
    
    template.level_4_transition = getTotalByLevel(max, path, False, TRANSITION, 4)
    template.level_4_state = getTotalByLevel(max, path, False, STATE, 4)
    template.level_4_time = getTotalByLevel(max, path, False, TIME, 4)
    
    template.level_5_transition = getTotalByLevel(max, path, False, TRANSITION, 5)
    template.level_5_state = getTotalByLevel(max, path, False, STATE, 5)
    template.level_5_time = getTotalByLevel(max, path, False, TIME, 5)
    
    template.level_6_transition = getTotalByLevel(max, path, False, TRANSITION, 6)
    template.level_6_state = getTotalByLevel(max, path, False, STATE, 6)
    template.level_6_time = getTotalByLevel(max, path, False, TIME, 6)

    template.level_dead_1_transition = getTotalByLevel(max, path, False, TRANSITION, 2)
    template.level_dead_1_state = getTotalByLevel(max, path, False, STATE, 2)
    template.level_dead_1_time = getTotalByLevel(max, path, False, TIME, 2)
    
    template.level_dead_2_transition = getTotalByLevel(max, path, False, TRANSITION, 2)
    template.level_dead_2_state = getTotalByLevel(max, path, False, STATE, 2)
    template.level_dead_2_time = getTotalByLevel(max, path, False, TIME, 2)
    
    template.level_dead_3_transition = getTotalByLevel(max, path, False, TRANSITION, 3)
    template.level_dead_3_state = getTotalByLevel(max, path, False, STATE, 3)
    template.level_dead_3_time = getTotalByLevel(max, path, False, TIME, 3)
    
    template.level_dead_4_transition = getTotalByLevel(max, path, False, TRANSITION, 4)
    template.level_dead_4_state = getTotalByLevel(max, path, False, STATE, 4)
    template.level_dead_4_time = getTotalByLevel(max, path, False, TIME, 4)
    
    template.level_dead_5_transition = getTotalByLevel(max, path, False, TRANSITION, 5)
    template.level_dead_5_state = getTotalByLevel(max, path, False, STATE, 5)
    template.level_dead_5_time = getTotalByLevel(max, path, False, TIME, 5)

    generateFile.write(str(template))
    os.chmod(path + "Reports/" + name, 0777)
    
        
if __name__ == '__main__':
    path = "/home/pedro/Pedro/Ferramenta2.1/gerador/Gerados/"
    max = int(sys.argv[1])
    gerarReportTemplate(max, path)
    
    
